//серво 36 нижний
// А6 вход термосопротивления
//бузер 3
// 1 варе 12
// порт 6 управляется через analogWrite (port6,0); 0-255
#include <Wire.h>
#include <LiquidCrystal_I2C.h>

LiquidCrystal_I2C lcd(0x27,20,4);

#include <LiquidCrystal.h>
#include <OneWire.h>
#include <EEPROM.h>
#include <Servo.h>

int butPin = 0;            // вход кнопок
int buzzer = 59;            // выход динамика(3)
int exitMenu = 1;          // выход из меню
int butPush = 1;           // код нажатой кнопки
int butRel=0;              // нажата ли сейчас кнопка
int val;                   // знач. АЦП при нажатой кнопке
int menu=0;                // текущий экран
int port1=22;               //ОХЛ ВОДА (Верхний разьём)
int port2=26;               //РАБОЧИЙ ТЕН
int port3=24;               //КЛАПАН  пуст (третья слева релюха)                                                                                       
int port4=28;               //КЛАПАН пуст (вторая слва релюха)
int port5=30;               //РАЗГОННЫЙ ТЭН
int port6=5;               // ЕРХНЯЯ РОЗЕТКА через SSR(1 работает/0 не работает)
int dt=0;                   // переменная терморезистора на блине.
int Rzm=0;                  //переменная резистора управления мощности сср
int VRzm=3;                 //вход переменного резистора управлением нагрузкой сср
int vdt=6;            // вход терморезистора А8
int Tcl=115;           //Температура клавирования
int Tclv=0;            //Верхний порог Т клавирования 
int Tcln=0;            //Нижний порог Т клавирования 
///////////// входы с галетного переключателя
int vgp1=8; 
int vgp2=9;
int vgp3=10;
int vgp4=11;
int vgp5=12;
/////////////переменные присваеваемые к анлог входам галетного переключателя
int gp1=0; 
int gp2=0;
int gp3=0;
int gp4=0;
int gp5=0;
//////////////
int srm=70;            //переменная мощности сыра при использовании крутилки
int stb=100;          //переменная температуры блина в сыре при использовании крутилки
int vbpr=0;            //переменнная выбора продукта
byte port1_stat=1;     // статус порта (включен/выключен
byte port2_stat=1;     //И ЧТО-БЫ НЕБЫЛО МУСОРА В ЗНАЧЕНИИ ПОРТА
byte port3_stat=1;    
byte port4_stat=1;  
byte port5_stat=1; 
byte port6_stat=0; 

byte f=0; // счётчик процессо
byte ff=0;
byte i;                    // счетчик
byte n;                    // счетчик
byte m=0;                   // счетчик

byte t=0;                   // счетчик
float kd=3.25;//83.42;     //крепость дистилята в дефлегматоре 83.42=45 в струе
float X;                // температура замерянная для работы
float sl;
float l=20;
float J;             //
float V=0.3;        //плюс к замерянной температуре отбора
float Z=2;     // плюс значение порога стопа
float Q=X+Z;      // значение порога конца процесса
   byte data[8];              // для хранения данных от датчика
unsigned long timer=0;     // таймер 
unsigned long procStTime=0;// время начала текущего процесса
unsigned long StTime=0;    // время запуска программы
float Tr1=97;             // Температура куба при которой завершается отбор товарного спирта
float Tr2=50;             //1/3 СМ КОЛОННЫ
float Tr3=80;             //Температура 1/3 при которой аварийно завешается процесс
float Tr4=99;             //Температура куба при Дожиме хвостов
int Pz1=0;                 // работа на себя пауза в минутах
int Pz2=0;              //головы
int Pz3=0;          // время приготовления тушёнки////
int Pz4=0;         //первый затоп /реально 3 мин
int Pz5=0;         //первое орашение/ реально 2 мин
int Pz6=0;         //второй затоп
int Pz7=0;         //второе орашение
int Pz8=0;         //третий затоп
int Pz9=0;         //третее орашение
int Pz10=0;        //полутело
int Pz11=1; //головы дистиля
int butval[8]={0,1023,817,602,407,203,0,0};   // АЦП кнопок
byte butsens=20;           // чувствительность кнопок
int keyvalue=0;            // для хранения АЦП при калибровке
boolean keysound=0;        // включен ли звук кнопок
int process=0;             // номер текущего процесса
boolean running = false;   // состояние программы
byte TotalDS=0;   // число найденых датчиков на линии
byte addr[4][8] = {
   {0,0,0,0,0,0,0,0},
   {0,0,0,0,0,0,0,0},
   {0,0,0,0,0,0,0,0},
   {0,0,0,0,0,0,0,0},
};  
float Tp[]={0,0,0,0};  
float T[]={0,0,0,0}; 
                   //T[0]-КУБ
                   //T[1]-20 СМ НАЧАЛО КОЛОННЫ
                   //T[2]-ВТОРАЯ ЦАРГА
                   //T[3]-Дефлегматор
                   //T[4]-Рубашка котла
                   //T[5]-Внутри котла
byte Stop=0;  
float sr=64;       //начальное положение сервопривода/закрыта заслонка/
float sX=120;      //положение сервопривода при отборе/плностью открыта заслонка/
 

OneWire  ds(12);            // на этот пин подключен DS
//LiquidCrystal (8, 9, 4, 5, 6, 7); //инициализация LCD
//lcd.init();
//lcd.backlight();
Servo myservo;   
boolean servo = false; // servo не используется по умолчанию

void setup()
{
   Tcln=Tcl-0,1;              // Температура - 0.2 к установленной готовки
    Tclv=Tcl+0,1;              // Температура + 0.2 к установленной готовки
 analogWrite(port6,0);
  float sl=sr+l ;
  myservo.attach(36 );
  lcd.begin(4, 20);
  lcd.init();
lcd.backlight();
  Serial.begin(9600);
  pinMode(port1, OUTPUT);     
  pinMode(buzzer, OUTPUT);
  pinMode(port2,  OUTPUT);
  pinMode(port3, OUTPUT);
  pinMode(port4 , OUTPUT);
  pinMode(port5 , OUTPUT);
  pinMode(port6 , OUTPUT);
 Serial.println(val );
   if (analogRead(butPin) > 50) { // процедура калибровки
    lcd.print("KALIBROVKA");
    lcd.setCursor(0,1);
    delay(2000);
    for ( i = 1; i < 6; i++) {
    lcd.clear();
    lcd.print("NAGMITE ");
    lcd.print(i, DEC);
    while (analogRead(butPin) < 100) {};
    button ();
    butval[i]=val;
    lcd.clear();
    lcd.setCursor(0,1);
    lcd.print(i, DEC);
    lcd.print(" ");
    lcd.print(butval[i], DEC);
    EEPROM.write(224+i*2,butval[i]/4); // по 2 байта на значение начиная с 224
    EEPROM.write(225+i*2,butval[i]%4);
    delay(1000);
    }
  } // конец калибровки
  else { // читаем АЦП кнопок
    for ( i = 0; i < 8; i++) {
      butval[i] = EEPROM.read(224+i*2)*4+EEPROM.read(225+i*2);
    }
  }
  read_DS();  //считываем адреса датчиков из памяти
  keysound = EEPROM.read(241);
  butsens = EEPROM.read(242); if (butsens < 5 || butsens > 100) { butsens = 20;}
  tone(buzzer, 1000); // включаем пищалку. Это сигнализация на случай если пропадет и снова появится питание
  
  
  lcd.print("buhlovodam privet");
  
}


byte read_DS() {
  for (n=0; n<4; n++) {
    for (i=0; i<8; i++) {
      addr[n][i] = EEPROM.read(128+n*8+i);
    }
  }
  return 0;
}


void loop()
       
{
 
   
    gp1=analogRead(vgp1);
    gp2=analogRead(vgp2);
    gp3=analogRead(vgp3);
    gp4=analogRead(vgp4);
    gp5=analogRead(vgp5);
    
    if (gp1>1000) {vbpr=1;}
     if (gp2>1000) {vbpr=2;}
      if (gp3>1000) {vbpr=3;}
       if (gp4>1000) {vbpr=4;}
        if (gp5>1000) {vbpr=5;}
        
    dt=analogRead(vdt);        // приравниваем перкмкнную к входу терморезистора.
    
    Rzm=analogRead(VRzm);      // приравниваем перкмкнную к входу переменного резистора.
 
    ds.reset();
    ds.write(0xCC,1);          // пропуск ROM
    ds.write(0x44,1);          // запускаем конвертацию
    for( n = 1; n < 90; n++) { //ждем 900 мс
      delay(10);            
      if (analogRead(butPin) > 50 && butRel) { Menu(button ()); } //периодически проверяя не нажата ли кнопка
      if (analogRead(butPin) < 60) {butRel=1;} //периодически проверяя не нажата ли кнопка
    }
    
  
    ///////////////////////////
      for( n = 0; n < 4; n++) {
      ds.reset();
      ds.select(addr[n]);
      ds.write(0xBE);         // считываем ОЗУ датчика
      for ( i = 0; i < 9; i++) {data[i] = ds.read();} // обрабатываем 9 байт
      Tp[n] = float((data[1] << 8) + data[0])/16;     // высчитываем температуру :)
      if (Tp[n] == 85) {} else {T[n]=Tp[n];}         // это для того, чтобы при глюке датчика (обычно при переключениях 
      // выдача температуры 85 град не приводила к переходу на другой шаг программы
      }
   
    timer=millis()/1000;         // текущее время в сек.
         boolean servo = true;
        {
          port1_stat=1;
        port2_stat=1;
       port3_stat=1;
       port4_stat=1;
       port5_stat=1;
      // port6_stat=0;
      digitalWrite(port2,port2_stat);
     digitalWrite(port3,port3_stat);
     digitalWrite(port4,port4_stat);
     digitalWrite(port1,port1_stat);
     digitalWrite(port5,port5_stat);
     digitalWrite(port6,port6_stat);
     }
         
  if (Stop) {running=0;}
    
    if (running) {
    switch (process) {
      case 0:
       
        running=0;
        for ( i = 0; i < 5; i++) {
        tone(buzzer, 1000);
        delay(500);
        noTone(buzzer);
        delay(500);
        }
      break; 
     
    
case 1:    //закипаем,по Т1 в царге пошли на следующий шаг
         myservo.write(sr);     //заслонка пара закрыта
         
       port2_stat=1;                //рабочий тэн отключён
       port3_stat=1;                //клапан охл.жидкости закрыт
       port4_stat=1;                //клапан отбора головзакрыт
       port5_stat=0;
       port1_stat=1;
       port6_stat=0;                   //клапан верхней розетки закрыт.
     if (T[1]>-10) { process++; }               //клапан пароголов/тела закрыт
        procStTime=timer;                                                                                                                                        
       
     
        break;
       case 2:   //на себя Pz1 минут
     
      myservo.write(sr);//заслонка пара закрыта
      port3_stat=0;//вода включена
      port1_stat=1;//разгонный тэн отключён
      port2_stat=0;//рабочий тен вкключён
      port4_stat=1;//клапан голов закрыт
      port5_stat=1;//клапан пароголов/тело закрыт
      port6_stat=0;//клапан верхней розетки закрыт.
     if (procStTime+Pz1*60 < timer) {process++;procStTime=timer;} //таймер Pz1
       
        break;
             
             case 3:   //головы Pz2 минут
     
      myservo.write(sr);//заслонка пара закрыта
      port3_stat=0;//вода включена
      port1_stat=1;//разгонный тэн отключён
      port2_stat=0;//рабочий тен отключён
      port4_stat=1;//клапан голов закрыт
      port5_stat=1;//клапан пароголов/тело закрыт
       port6_stat=0;//клапан верхней розетки закрыт.
     if (procStTime+Pz2*60 < timer) {process++;procStTime=timer;} //таймер Pz2
      
     if (T[1]>Tr3){ process=13;} //если температура охл.жидкости в норме,работаем
            break;
            
            case 4:   //нетоварный Pz10 минут
     
      myservo.write(sX);//заслонка пара открыта
      port3_stat=0;//вода включена
      port1_stat=1;//разгонный тэн отключён
      port2_stat=0;//рабочий тен включён
      port4_stat=1;//клапан голов закрыт
      port5_stat=1;//клапан пароголов/тело закрыт
       port6_stat=1;//клапан верхней розетки закрыт.
     if (procStTime+Pz10*60 < timer) {process++;procStTime=timer;} //таймер Pz10
      
     if (T[1]>Tr3){ process=10;} //если температура охл.жидкости в норме,работаем
           break;
            
            
            case 5:  //замеряем пороговую температуру
      myservo.write(sX);   //заслонка пара открыта
     port1_stat=1;         //разгонный тэн отключён
      port2_stat=0;        //рабочий тэн включён
      port3_stat=0;        //вода включена
     port4_stat=1;         //клапан отбора голов закрыт
     port5_stat=0;         //клапан пароголов/тело открыт
     port6_stat=0;         //клапан верхней розетки закрыт.
    X= (T[1]);             // замеряли пороговою температуру Х 
    Serial.println(X );
    process++;
            
            case 6:   //рабочий процесс
                      //работаем по пороговой переменной Х+0.3в 1/3 колонны,до достижения Tr1 в кубе
           //Serial.println(X   );
        // Serial.println(" " );
          Q=X+Z; //ПЕРЕМЕННАЯ СТОПА
           J=X+V;//ПЕРЕМЕННАЯ ЗАСЛОНКИ ПАРА     
         
     port1_stat=1;       //разгонный тэн отключён
     port2_stat=0;       //рабочий тэн включён
     port3_stat=0;       //вода открыта 
     port4_stat=1;        //клапан отбора голов закрыт
     port5_stat=1;        //клапан пароголов/тело закрыт
     
     if (T[1]<=J) {myservo.write(sX);}//если температура в 1/3 ниже пороговой,заслонка открыта
     else 
       myservo.write(sr);//если выше,закрыта
       if (T[1]<=J) {port6_stat=1;}//если температура в 1/3 ниже пороговой, клапан верхней розетки открыт
     else 
       port6_stat=0;//клапан верхней розетки закрыт.
       if (T[0]>90) {sX=115;}
       if (T[0]>92) {sX=113;}
       if (T[0]>95) {sX=110;}
       if (T[0]>96) {sX=105;}
         if (T[1]>Tr3){ process=11;} //если температура охл.жидкости выше шагаем на авар.кейс
          if (T[0]>Tr1){ process++;} //если температура куба выше шагаем дальше 
         
            break;
 
            
            case 7:    //рабочий процесс 2 отжимаем хвосты
                      //работаем по пороговой переменной Х+0.3в 1/3 колонны,до достижения Tr1 в кубе
       Q=X+Z; //ПЕРЕМЕННАЯ СТОПА
       J=X+V;//ПЕРЕМЕННАЯ ЗАСЛОНКИ ПАРА     
     port1_stat=1;       //разгонный тэн отключён
     port2_stat=0;       //рабочий тэн включён
     port3_stat=0;       //вода открыта 
     port4_stat=1;        //клапан отбора голов закрыт
     port5_stat=1;        //клапан пароголов/тело закрыт
     if (T[1]<=J) {myservo.write(sX);}//если температура в 1/3 ниже пороговой,заслонка открыта
     else myservo.write(sr);//если выше,закрыта
     if (T[1]<=J) {port6_stat=1;}//если температура в 1/3 ниже пороговой, клапан верхней розетки открыт
     else 
       port6_stat=0;//клапан верхней розетки закрыт.
       if (T[0]>96) {sX=105;}
         if (T[1]>Tr3){ process=12;} //если температура охл.жидкости выше шагаем на авар.кейс
          if (T[0]<Tr1-1){ process--;} //если температура куба выше шагаем дальше 
         if (T[0]>Tr4){ process++;} //если температура куба выше шагаем дальше 
            break;
            
             case 8:  // от глюка датчиков
     port1_stat=1;       //разгонный тэн отключён
     port2_stat=0;       //рабочий тэн включён
     port3_stat=0;       //вода открыта 
     port4_stat=1;        //клапан отбора голов закрыт
     port5_stat=1;        //клапан пароголов/тело закрыт
      myservo.write(sr);//закрыта
       if (T[0]<Tr4-1){ process--;} //если температура куба выше шагаем дальше 
         if (T[0]>=Tr4){ process++;} //если температура куба выше шагаем дальше 
            break;
     
   
 
     case 9:   // завершаем процесс
     port1_stat=1;       //разгонный тэн отключён
     port2_stat=1;       //рабочий тэн выключён
     port3_stat=1;       //вода закрыта 
     port4_stat=1;        //клапан отбора голов закрыт
     port5_stat=1;        //клапан пароголов/тело закрыт
      myservo.write(sr);//закрыта
       if (T[0]<Tr4-1){ process--;} //если температура куба выше шагаем дальше 
         if (T[0]>=Tr4){ Stop;} //если температура куба выше шагаем дальше 
            break;
            
            case 10:    // аварийный нетоварный
          if (T[1]<=Tr3-2){ process=4;} //если температура охл.жидкости выше шагаем на авар.кейс
          if (T[1]>Tr3){ Stop;} //если температура царги выше стоп 
         
            break;
 
                   case 11:  
                    // аварийный рабочий
   
         if (T[1]<=Tr3-2){ process=6;} //если температура охл.жидкости выше шагаем на авар.кейс
         if (T[1]>Tr3){ Stop;} //если температура царги выше стоп 
         
            break;
     
 
     case 12:     // аварийный отжим
   
         if (T[1]<=Tr3-2){ process=7;} //если температура охл.жидкости выше шагаем на авар.кейс
          if (T[1]>Tr3){ Stop;} //если температура царги выше стоп 
         
            break;
 
     case 13:   // аварийный головы
         myservo.write(sr);
         if (T[1]<=Tr3-2){ process=3;} //если температура охл.жидкости выше шагаем на авар.кейс
          port1_stat=1;       
     port2_stat=1;       
     port3_stat=1;       
     port4_stat=1;        
     port5_stat=1; 
   break;
    
   case 18: //готовим тушенку //Выходим на 120С
          
     if (T[0]>=Tcl) { process++; }    //как вышли на Т шагаем
     if (T[0]<=1) { process=21; }    // от глюка
      analogWrite (port6,255);       // разетка включена на полную
     if (dt>600) { analogWrite (port6,0);} //если блин нагреется выше 600 отключить питпние.
        procStTime=timer;                                                                                                                                        
        
  
        break; 
            
   case 19:   //врим тушняк.
       if (T[0]>=Tcl) {analogWrite (port6,0);}  // Т больше установленной не варим.
        if (T[0]<=1) { process=22; }    // от глюка
       if (T[0]<=Tcl) {analogWrite (port6,Rzm / 4.011764);}  // Т меньше установленной варим.с мощностью на крутилке
        if (dt>500) {analogWrite (port6,0);}  // если блин греется выше 500 выключаем
        if (procStTime+Pz3*60 < timer) {process++;procStTime=timer;} //таймер Pz3
       
        break;
            
    case 20: //стоп.тушняк готов
     
     procStTime=timer;
      analogWrite (port6,0);//разетка выключена
    
            break;
             case 21:   //глюк датчика закипаем
       
        if (T[0]<=1) { process=22; }    // от глюка
       if (T[0]>1) { process=18; }    // от глюка
       
        break;
            
            case 22: //Глюк датчика
     
     procStTime=timer;
      analogWrite (port6,0);//разетка выключена
    
            break;
            case 23:   //глюк датчика готовим
       
        if (T[0]<=1) { process=22; }    // от глюка
       if (T[0]>1) { process=19; }    // от глюка
       
        break;
            
            
         case 25:   //Гоним СС
              if (T[0]<=100) {port1_stat=0;}
              else  port1_stat=1;
              if (T[0]>100) {port2_stat=0;}
              if (T[1]>100) { process++; }
              procStTime=timer; 
         break;
            
         case 26:   //от глюка СС
               port2_stat=0;
              if (T[1]<98) {process--;}
              if (T[1]>=100) {process++;}
         break;
            
            case 27:   //Процесс окончен
               port3_stat=1;//вода включена
               port1_stat=1;//разгонный тэн отключён
               port2_stat=1;//рабочий тен включён
               port4_stat=1;//клапан голов закрыт
               port5_stat=1;
              {tone(buzzer, 1000); delay(1000); noTone(buzzer);delay(1000);tone(buzzer, 1000);process++;procStTime=timer;} 
         break;
            
            
           case 30:   //врим сыр//пастеризация молока.
              if (T[0]>=72) {analogWrite (port6,0);tone(buzzer, 1000); delay(1000); noTone(buzzer);delay(1000);tone(buzzer, 1000);process++;procStTime=timer;}  // Т больше установленной не варим.
              if (T[0]<72) {analogWrite (port6,255);}  // Т меньше установленной варим.с мощностью на крутилке
              if (dt>500) {analogWrite (port6,0);}  // если блин греется выше 500 выключаем
           break;
            
            case 31:   //врим сыр//ждём команды
                  if (butPush == 3) {process++;}
            break;
            
            case 32:   //врим сыр//
              if (T[0]>=Rzm/23) {analogWrite (port6,0);tone(buzzer, 1000); delay(1000); noTone(buzzer);delay(1000);tone(buzzer, 1000);process++;procStTime=timer;}  // Т больше установленной не варим.
              if (T[0]<Rzm/23) {analogWrite (port6,srm);}  // Т меньше установленной варим.с температурой на крутилке
              if (dt>stb) {analogWrite (port6,0);}  // если блин греется выше 100 выключаем
              if (butPush == 1) {srm=Rzm / 4.011764;}
              if (butPush == 5) {stb=Rzm / 4.011764;}
           break;
            
            
            
            
            
            
           } 
             digitalWrite(port1, port1_stat);
             digitalWrite(port2,port2_stat);
             digitalWrite(port3,port3_stat);
             digitalWrite(port4,port4_stat);
             digitalWrite(port5,port5_stat);
           }
      Menu(0);
    }
      int button () {
    butPush = 1; // код нажатой кнопки
    exitMenu=1;  // переменная разрешающая продолжение цикла опроса
    if (keysound) {tone(buzzer, 1000);}
    while(exitMenu) {
   val = analogRead(butPin);  // читаем АЦП порта кнопок (значение от 0 до 1023)
    if (val > (butval[5]-butsens) && val < (butval[5]+butsens)) {butPush = 5;}  
    if (val > (butval[4]-butsens) && val < (butval[4]+butsens)) {butPush = 4;}
    if (val > (butval[3]-butsens) && val < (butval[3]+butsens)) {butPush = 3;}
    if (val > (butval[2]-butsens) && val < (butval[2]+butsens)) {butPush = 2;}
    if (val > (butval[1]-butsens) && val < (butval[1]+butsens)) {butPush = 1;}
    butRel=0;
    delay(10);  // задержка для устранения дребезга контактов
    if (val < 1000 && butPush > 0) {exitMenu=0;} // если кнопка была нажата а затем отпущена,
    // то выходим из цикла опроса
    }
    noTone(buzzer);
  return butPush;
}

void printTimer () {
       if (process == 1 ) {
       lcd.print(" __:__"); }
       else {
          switch (process) {
            
           case 2:
           timer=Pz1*60+procStTime-timer;
           break; 
           
           case 3:
           timer=Pz2*60+procStTime-timer;
           break; 
           
           case 4:
           timer=Pz10*60+procStTime-timer;
          break; 
          
           case 19:
           timer=Pz3*60+procStTime-timer;
           break; 
           
          // case 6:
          // timer=Pz8*60+procStTime-timer;
          // break; 
           
          // case 7:
          // timer=Pz9*60+procStTime-timer;
          // break; 
           
          // case 8:
          // timer=Pz1*60+procStTime-timer;
          // break; 
           
          // case 9:
          // timer=Pz2*60+procStTime-timer;
          // break; 
           
          // case 10:
          // timer=Pz10*60+procStTime-timer;
          // break; 
          }
         n=timer/60;
         if (n < 100) lcd.print(" "); 
         if (n < 10) lcd.print(" "); 
         lcd.print(n,DEC);
         lcd.print(":"); 
         n=timer-(timer/60)*60;
         if (n < 10) lcd.print("0"); 
         lcd.print(n,DEC);    
       } 
}
byte write_DS() {
  for (i=0; i<8; i++) {
    if (m==0) {EEPROM.write(128+t*8+i,0);}
    else {EEPROM.write(128+t*8+i,addr[m-1][i]);}
    }
  return 0;
}

void Menu(int butPush) {
    lcd.clear();
    switch (menu) { 
      case 0:
       if (vbpr==1){ lcd.print("DELAEM SPIRT ");lcd.setCursor(0,1);lcd.print("OTBOR GOLOV ");lcd.print(Rzm/2);lcd.print(" MIN ");} 
       if (vbpr==5){ lcd.print("GONIM CC ");} 
       if (vbpr==4){ lcd.print("GOTOVIM TUSHONKU");lcd.setCursor(0,1);lcd.print(Tcl);lcd.print(" GRADUSOV");lcd.setCursor(0,2);
     lcd.print(Rzm/8);lcd.print(" MINUT");} 
       if (vbpr==3){ lcd.print("GOTOVIM SIR ");} 
       if (vbpr==2){ lcd.print("BRODIM PIVO ");} 
       lcd.setCursor(0,3);
      lcd.print("MENU NASTROEK ^ ");
      
      
  
       {
    if (vbpr==4)  
       {
       if (butPush == 2) {Tcl=Tcl-1; }
       if (Tcl >119) {Tcl=119;}
        //if (butPush == 4) {menu++; Menu(0);}
       // if (butPush == 1) {menu=20; Menu(0);}
        if (butPush == 4) {Tcl=Tcl+1;}
       }
    else 
       {
        if (butPush == 2) {menu=4; Menu(0);}
        if (butPush == 4) {menu++; Menu(0);}
        if (butPush == 1) {menu=20; Menu(0);}
        if (butPush == 5) {menu=40; Menu(0);}
        }
    }
     
     
     
       if (butPush == 3)  {
                           if(vbpr==1){Pz2=Rzm/2;running=1;process=1;Menu(0);menu=1;} 
                           if(vbpr==4){Pz3=Rzm/8;running=1;process=18;Menu(0);menu=1;} 
                           if(vbpr==5){running=1;process=25;Menu(0);menu=1;} 
                           }
                         // } 
       
      //  {running=1;process=1;Menu(0);menu=1;}
        break;
      
      
      case 1: // основной экран, показываем температуру, шаг, на котором находится программа, и  таймер
          lcd.print("CUB ");
          lcd.print(T[0]); // температура
          lcd.setCursor(10,0);
          if ((Stop)) {lcd.clear();lcd.print("ERROR");} 
          else  {
          {lcd.print("NORMAL");}
          lcd.setCursor(0,1);
          switch (process) {
            case 0: {
              lcd.print("Stop"); 
              break;
              }
           case 1: {
       lcd.print("^"); 
        lcd.print(T[1]); 
        break;
          }
          case 2: {
        lcd.print("NA SEBY"); 
       // lcd.print(T[1]); 
        break;
          }
          case 3: { 
            lcd.clear();
        lcd.print("GOLOVI "); 
       // lcd.setCursor(1,2);
        lcd.print(T[0]);
        lcd.print(" "); 
        lcd.print(T[1]);
        lcd.setCursor(0,3);
       // printTimer();
        lcd.setCursor(1,2);
         lcd.print("ZASLONKA ZAKR  ");lcd.print(sr);
       // lcd.print(T[1]); 
        break;
          }   
         case 4: {
          // lcd.clear();
        lcd.print("OBOROTN"); 
      //  lcd.print(T[1]); 
        break;
          }        
          case 5: {
        lcd.print("ZAMER X"); 
       // lcd.print(T[1]); 
        break;
          }
        case 6: {
        lcd.print("GONIM"); 
        lcd.setCursor(7,1);
        lcd.print("1/3- ");
        lcd.print(T[1]);
        lcd.setCursor(0,2); 
         if (T[1]<=J) {lcd.print("ZASLONKA OTKR  ");lcd.print(sX);}
         if (T[1]>J) {lcd.print("ZASLONKA ZAKR  ");lcd.print(sr);}
         lcd.setCursor(0,3);
         lcd.print("X "); 
         lcd.print(X);
         lcd.print(" J ");
         lcd.print(J);
     
        break;
        }
        case 7: {
        lcd.print("HVOSTY"); 
        lcd.setCursor(0,2); 
         if (T[1]<=J) {lcd.print("ZASLONKA OTKR  ");lcd.print(sX);}
         if (T[1]>J) {lcd.print("ZASLONKA ZAKR  ");lcd.print(sr);}
       
        break;
         }
          case 8: {
        lcd.print("GLUK"); 
       // lcd.print(T[1]); 
        break;
        }
        
        case 9: {
        lcd.print(" GOTOVO"); 
       // lcd.print(T[1]); 
        break;
        }
        case 10: {
        lcd.print("AVAAR OBOR"); 
        lcd.print(T[1]); 
        break;
        }  
         case 11: {
        lcd.print("AVAR RAB"); 
        lcd.print(X); 
        break;
        }
          
          case 12: {
        lcd.print("AVAR HVOST"); 
        lcd.print(T[1]); 
        break;
        }
         case 13: lcd.clear();
          {
        lcd.print("AVAR GOLOVY ");
           lcd.print("Z ZAKR  ");lcd.print(sr);
        lcd.setCursor(0,1); 
        
        }
         case 18: 
        {
       lcd.clear();
       lcd.print("ZAKIPAEM "); 
       lcd.print(Tcl); 
       lcd.setCursor(0,1);
       lcd.print("V KASTRULE "); 
        lcd.print(T[0]); 
        lcd.setCursor(0,2);
       lcd.print("NA BLINE "); 
       lcd.print(dt);
        lcd.print(" ");
         lcd.print(Rzm*0.09765625);
        lcd.print("% ");
       lcd.setCursor(0,3);
       lcd.print("OSTALOS ");
       
      
        break;
           }
      
         case 19:{
        lcd.clear();
       lcd.print("GOTOVIM "); 
        lcd.print(Tcl); 
        lcd.print("C "); 
        lcd.print(Pz3); 
      lcd.print(" MIN"); 
       lcd.setCursor(0,1);
       lcd.print("V KASTRULE "); 
        lcd.print(T[0]); 
        lcd.setCursor(0,2);
       lcd.print("NA BLINE "); 
       lcd.print(dt);
       lcd.setCursor(0,3);
       lcd.print(Rzm*0.09765625);
        lcd.print("% ");
       //if (T[0]<=Tcln) {lcd.print(" ON  ");}
       // if (T[0]>=Tclv) {lcd.print(" OFF  ");}
        break;
          }
        
       case 20: {
       lcd.clear();
       lcd.print("PROCESS OKONCHEN"); 
       lcd.setCursor(0,1);
       lcd.print("V KASTRULE "); 
        lcd.print(T[0]); 
        lcd.setCursor(0,2);
       lcd.print("NA BLINE "); 
       lcd.print(dt);
       lcd.setCursor(0,3);
       lcd.print(Rzm*0.09765625);
        lcd.print("% ");
        break;
          }   
          case 21: {
       lcd.clear();
       lcd.print("----------------"); 
       lcd.setCursor(0,1);
       lcd.print("V KASTRULE "); 
        lcd.print(T[0]); 
        lcd.setCursor(0,2);
       lcd.print("NA BLINE "); 
       lcd.print(dt);
       lcd.setCursor(0,3);
       lcd.print(Rzm*0.09765625);
        lcd.print("% ");
        break;
          }   
          
          case 22: {
       lcd.clear();
       lcd.print("GLUIK <0 "); 
       lcd.setCursor(0,1);
       lcd.print("V KASTRULE "); 
        lcd.print(T[0]); 
        lcd.setCursor(0,2);
       lcd.print("NA BLINE "); 
       lcd.print(dt);
       lcd.setCursor(0,3);
       lcd.print(Rzm*0.09765625);
        lcd.print("% ");
        break;
          }  
          case 23: {
       lcd.clear();
       lcd.print("----------------"); 
       lcd.setCursor(0,1);
       lcd.print("V KASTRULE "); 
        lcd.print(T[0]); 
        lcd.setCursor(0,2);
       lcd.print("NA BLINE "); 
       lcd.print(dt);
       lcd.setCursor(0,3);
       lcd.print(Rzm*0.09765625);
        lcd.print("% ");
        break;
          }    
        
         case 25: {
       lcd.clear();
       lcd.print("GONIM CC"); 
       lcd.setCursor(0,1);
       lcd.print("V RUBASHKE "); 
        lcd.print(T[0]); 
        lcd.setCursor(0,2);
       lcd.print("V CUBE "); 
       lcd.print(T[1]);
       break;
          }   
          
          case 26: {
       lcd.clear();
       lcd.print("GLUK CC"); 
       break;
          }   
          
         case 27: {
       lcd.clear();
       lcd.print("PROCESS OKONCHEN"); 
       lcd.print("V RUBASHKE "); 
        lcd.print(T[0]); 
        lcd.setCursor(0,2);
       lcd.print("V CUBE "); 
       lcd.print(T[1]);
        break;
          }    
          
       case 30: {
         lcd.clear();
         lcd.print("PASTERIZUEM MOLOKO"); 
         lcd.setCursor(0,1);
         lcd.print("72C "); 
       break;
          }
          
          case 31: {
         lcd.clear();
         lcd.print("PASTERIZUEM MOLOKO"); 
         lcd.setCursor(0,1);
         lcd.print("72C "); 
       break;
          }
          
          
          
          
        }
       printTimer();   
     }
        
       
        if (butPush == 1) {menu=20; Menu(0);}
        if (butPush == 2) {menu=0; Menu(0);}
        if (butPush == 4) {menu++; Menu(0);}
       // if (butPush == 4) {menu=54; Menu(0);}
      break;

    case 2:
      if ((Stop)) {lcd.clear();lcd.print("ERROR");} else  {lcd.print("1:");
        lcd.print(T[0]);
        lcd.setCursor(8,0);
        lcd.print("2:");
        lcd.print(T[1]);
        lcd.setCursor(0,1);
        lcd.print("3:");
        lcd.print(T[2]);
        lcd.setCursor(8,1);
        lcd.print("4:");
        lcd.print(T[3]);}
 
        if (butPush == 2) {menu--; Menu(0);}
        if (butPush == 4) {menu++; Menu(0);}
        if (butPush == 3) {menu=1; Menu(0);}
        if (butPush == 1) {menu=20; Menu(0);}
        break;
        
        case 3:
        if ((Stop)) {lcd.clear();lcd.print("ERROR");} else  {lcd.print("CUB");
        lcd.print(T[0]);
        lcd.setCursor(8,0);
        lcd.print("1/3");
        lcd.print(T[1]);
        lcd.setCursor(0,1);
        lcd.print("X");
        lcd.print(X);
        lcd.setCursor(8,1);
        lcd.print("J");
        lcd.print(J);}
        if (butPush == 2) {menu--; Menu(0);}
        if (butPush == 4) {menu++; Menu(0);}
        if (butPush == 3) {menu=1; Menu(0);}
        if (butPush == 1) {menu=20; Menu(0);}
        break;
        
      case 4: // запуск процесса
        if (process) {
          lcd.print("Process active");
          lcd.setCursor(0,1);
          timer=timer-StTime;
          lcd.print(timer/60);
          lcd.print(":"); 
          n=timer-(timer/60)*60;
          if (n < 10) lcd.print("0"); 
          lcd.print(n,DEC);   
         }
        else {lcd.print("Process stopped");
      lcd.setCursor(0,1);
      lcd.print("pres 3 start");
    }
         if (butPush == 2) {menu--; Menu(0);}
       if (butPush == 3) {
        if (running) {process=0; Menu(0);}
        else {running=1; process=1; StTime=timer;  Menu(0);}    }
        if (butPush == 4) {menu=0; Menu(0);}
      break;      

      case 20: // меню настроек
        lcd.print("nastroyki  < >");
        lcd.setCursor(0,1);
        lcd.print("Click 5 exit");
        if (butPush == 2) {menu=30; Menu(0);}
        if (butPush == 4) {menu++; Menu(0);}
        if (butPush == 3) {menu=1; Menu(0);}
       // if (butPush == 5) {menu=0; Menu(0);}
      break;      
      
      case 21: // меню настроек
        lcd.print("Key Sound");
        lcd.setCursor(0,1);
        if (keysound) {lcd.print("    Enabled");}
        else  {lcd.print("    Disabled");}
        if (butPush == 2) {menu--; Menu(0);}
        if (butPush == 1 || butPush == 5) {keysound=!keysound; Menu(0);}
        if (butPush == 4) {menu++; Menu(0);}
        if (butPush == 3) {menu=1; Menu(0);}
      break;      

      case 22: // меню настроек
        lcd.print("Key sensitive");
        lcd.setCursor(0,1);
        lcd.print(butsens, DEC);
        if (butPush == 2) {menu--; Menu(0);}
        if (butPush == 5) {butsens--; Menu(0);}
        if (butPush == 1) {butsens++; Menu(0);}                
        if (butPush == 4) {menu++; Menu(0);}
        if (butPush == 3) {menu=1; Menu(0);}
      break; 
      
      case 23: // поиск датчиков
        i = 0;
        n=0;
        while (i != 1 ) /// ищем датчики 
        {
          if ( ds.search(addr[n]) != 1) {
            ds.reset_search();
            i = 1; }
          else { 
            n++; 
            TotalDS = n;
          }
        }
        lcd.print("Poisk datchikov");
        lcd.setCursor(0,1);
        lcd.print(n, DEC);
        lcd.print("Naydeno Click 1");
        if (butPush == 2) {menu--; Menu(0);}
        if (butPush == 1) {menu=100; Menu(0);}
        if (butPush == 5) {menu++; Menu(0);}
        if (butPush == 3) {menu=1; Menu(0);}
      break;
      
      case 24: 
        
        lcd.print("RABOTA NA SEBY:");
        lcd.setCursor(0,1);
        lcd.print(Pz1);
        lcd.print("min");
        if (butPush == 2) {menu--; Menu(0);}
        if (butPush == 5) {Pz1=Pz1-10; Menu(0);}
        if (butPush == 1) {Pz1=Pz1+10; Menu(0);}
        if (butPush == 4) {menu++;Menu(0);}
        if (butPush == 3) {menu=1; Menu(0);}
      break;
      
    case 25: 
        
        lcd.print("OTBOR GOLOV ");
        lcd.setCursor(0,1);
        lcd.print(Pz2);
        lcd.print("min");
        if (butPush == 2) {menu--; Menu(0);}
        if (butPush == 5) {Pz2=Pz2-10; Menu(0);}
        if (butPush == 1) {Pz2=Pz2+10; Menu(0);}
        if (butPush == 4) {menu++;Menu(0);}
        if (butPush == 3) {menu=1; Menu(0);}
      break;
      
      case 26: 
       
        lcd.print("NE TOVARNIY:");
        lcd.setCursor(0,1);
        lcd.print(Pz10);
        if (butPush == 2) {menu--; Menu(0);}
        if (butPush == 5) {Pz10=Pz10-10; Menu(0);}
        if (butPush == 1) {Pz10=Pz10+10; Menu(0);}
        if (butPush == 4) {menu++;Menu(0);}
        if (butPush == 3) {menu=1; Menu(0);}
      break;

      case 27: 
     
        lcd.print("ZASLONKA OTKR");
        lcd.setCursor(0,1);
        lcd.print(sX);
        if (butPush == 2) {menu--; Menu(0);}
        if (butPush == 5) {sX=sX--; Menu(0);}
        if (butPush == 1) {sX=sX++; Menu(0);}
        if (butPush == 4) {menu++; Menu(0);}
        if (butPush == 3) {menu=1; Menu(0);}
      break;      
      
      case 28: 
      
         lcd.print("ZASLONKA ZAKR");
        lcd.setCursor(0,1);
        lcd.print(sr);
        if (butPush == 2) {menu--; Menu(0);}
        if (butPush == 5) {sr=sr--; Menu(0);}
        if (butPush == 1) {sr=sr++; Menu(0);}
        if (butPush == 4) {menu++; Menu(0);}
        if (butPush == 3) {menu=1; Menu(0);}
      break;

      case 29: 
     // настройка времяни работы на себя
         lcd.print("rabota na seby:");
        lcd.setCursor(0,1);
        lcd.print(Pz1);
        lcd.print(":00");
        if (butPush == 2) {menu--; Menu(0);}
        if (butPush == 5) {Pz1--; Menu(0);}
        if (butPush == 1) {Pz1++; Menu(0);}
        if (butPush == 4) {menu++; Menu(0);}
        if (butPush == 3) {menu=1; Menu(0);}
      break;
      
      case 30: //Максимальная температура в кубе
       lcd.print("maksimalnaya ");
       lcd.setCursor(0,1);
       lcd.print(" temperatura v kube:");
        lcd.setCursor(0,2);
        lcd.print(Tr1);
        if (butPush == 2) {menu--; Menu(0);}
        if (butPush == 3) {Tr1=Tr1-0.1; Menu(0);}
        if (butPush == 1) {Tr1=Tr1+0.1; Menu(0);}
        if (butPush == 4) {menu=20; Menu(0);}
        if (butPush == 5) {menu=1; Menu(0);}
      break;
      
      
     
        
        
      case 40:
        lcd.print("rektifikat gmi ^");
        lcd.setCursor(0,1);
        lcd.print("NDRF gmi v");
        lcd.setCursor(0,2);
        lcd.print("     <  MENU  >");
        if (butPush == 1) {{ff=1;running=1; process=1; StTime=timer;menu=1;  Menu(0);}}
       if (butPush == 3) {{ff=5;running=1; process=1; StTime=timer;menu=1;  Menu(0);}}
        if (butPush == 4) {menu++; Menu(0);}
        break;

        case 41:
        lcd.print("DISTILYAT gmi ^");
        lcd.setCursor(0,1);
        lcd.print("TUSHONKA gmi v");
        if (butPush == 3) {{;running=1; process=14; StTime=timer;menu=1;  Menu(0);}}
       //if (butPush == 3) {menu=1; Menu(0);}
        if (butPush == 1) {menu=40; Menu(0);}
        break;

         case 100: // меню настроек датчиков DS1820
        lcd.print("T   ^ v ");
        lcd.print(t+1,DEC);
        lcd.setCursor(0,1);
        if (m==0) {lcd.print("Netu");}
           else {lcd.print(T[m-1],DEC);}
        if (butPush == 1) {if (t==0) {menu=100;} else {t--;} Menu(0);}
        if (butPush == 2) {if (m==0) {} else {m--;} Menu(0);}
        if (butPush == 3) {write_DS(); lcd.setCursor(0,1); lcd.print("Zapisano v EEPROM"); tone(buzzer, 1000); delay(1000); noTone(buzzer); menu=100; Menu(0);}
        if (butPush == 4) {m++; if (m>(TotalDS)) {m=TotalDS;} Menu(0);}
        if (butPush == 5) {if (t==6) {menu=101;} else {t++;}  Menu(0);}
      break; 

      case 101: // Выход из меню
        lcd.print("Vyiyti iz menu");
        lcd.setCursor(0,1);
        lcd.print("3 dly vihoda");
       
        if (butPush == 3) {menu=23; Menu(0);}
        
      break;      



    } // end switch

}


